/* Ce programme matAlea calcule aleatoirement les coefficients d'une 
   matrice N*M et stocke cette matrice dans le fichier "matAlea.dat"
   NB : quand matAlea a termine son execution, on lance un autre
   programme (qui est hors du contexte de cet exercice) qui utilise
   la matrice stockee dans matAlea.dat pour faire un traitement.
*/

#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

#define NOMFIC "/tmp/matAlea.dat"
#define N      50
#define M      40

int mat[N][M];

int main() {
  int fd;
  int i,j;

  srand(getpid());

  /* Calcul aleatoire des coefficients de la matrice */
  for (i=0 ; i<M ; i++){
    for (j=0 ; j<N ; j++){
      mat[j][i] = rand();
    }
  }

  /* Stockage dans fichier */
  fd = open(NOMFIC,
	    O_WRONLY|O_CREAT|O_TRUNC|O_SYNC,
	    S_IRUSR|S_IWUSR);
  if (fd < 0){
    perror("open");
    return EXIT_FAILURE;
  }

  for (i=0 ; i<N ; i++){
    for (j=0 ; j<M ; j++){
      if (lseek(fd, (j+i*M)*sizeof(int), SEEK_SET) < 0){
	perror("lseek");
	return EXIT_FAILURE;
      }
      if (write(fd, &mat[i][j], sizeof(int)) != sizeof(int)){
	perror("write");
	return EXIT_FAILURE;
      }
    }
  }
  if (close(fd) < 0){
    perror("close");
    return EXIT_FAILURE;
  }
  return EXIT_SUCCESS;
}
